# coding: utf-8

"""
    Phoenix API

    Base API for Glumanda and other services.

    The version of the OpenAPI document: Alpha
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from phoenix_sdk.models.unit_group_schema_out import UnitGroupSchemaOut
from phoenix_sdk.models.unit_platform_type import UnitPlatformType
from typing import Optional, Set
from typing_extensions import Self

class UnitSchemaOut(BaseModel):
    """
    UnitSchemaOut
    """ # noqa: E501
    created_by_id: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    name: Optional[StrictStr] = None
    conf: Optional[Dict[str, Any]] = None
    address_id: Optional[StrictStr] = None
    parent_id: Optional[StrictStr] = None
    company_id: Optional[StrictStr] = None
    unit_group_id: Optional[StrictStr] = None
    unit_platform: Optional[UnitPlatformType] = None
    unit_group: Optional[UnitGroupSchemaOut] = None
    __properties: ClassVar[List[str]] = ["created_by_id", "id", "created_at", "updated_at", "name", "conf", "address_id", "parent_id", "company_id", "unit_group_id", "unit_platform", "unit_group"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UnitSchemaOut from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of unit_group
        if self.unit_group:
            _dict['unit_group'] = self.unit_group.to_dict()
        # set to None if created_by_id (nullable) is None
        # and model_fields_set contains the field
        if self.created_by_id is None and "created_by_id" in self.model_fields_set:
            _dict['created_by_id'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if updated_at (nullable) is None
        # and model_fields_set contains the field
        if self.updated_at is None and "updated_at" in self.model_fields_set:
            _dict['updated_at'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if conf (nullable) is None
        # and model_fields_set contains the field
        if self.conf is None and "conf" in self.model_fields_set:
            _dict['conf'] = None

        # set to None if address_id (nullable) is None
        # and model_fields_set contains the field
        if self.address_id is None and "address_id" in self.model_fields_set:
            _dict['address_id'] = None

        # set to None if parent_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_id is None and "parent_id" in self.model_fields_set:
            _dict['parent_id'] = None

        # set to None if company_id (nullable) is None
        # and model_fields_set contains the field
        if self.company_id is None and "company_id" in self.model_fields_set:
            _dict['company_id'] = None

        # set to None if unit_group_id (nullable) is None
        # and model_fields_set contains the field
        if self.unit_group_id is None and "unit_group_id" in self.model_fields_set:
            _dict['unit_group_id'] = None

        # set to None if unit_platform (nullable) is None
        # and model_fields_set contains the field
        if self.unit_platform is None and "unit_platform" in self.model_fields_set:
            _dict['unit_platform'] = None

        # set to None if unit_group (nullable) is None
        # and model_fields_set contains the field
        if self.unit_group is None and "unit_group" in self.model_fields_set:
            _dict['unit_group'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UnitSchemaOut from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_by_id": obj.get("created_by_id"),
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "name": obj.get("name"),
            "conf": obj.get("conf"),
            "address_id": obj.get("address_id"),
            "parent_id": obj.get("parent_id"),
            "company_id": obj.get("company_id"),
            "unit_group_id": obj.get("unit_group_id"),
            "unit_platform": obj.get("unit_platform"),
            "unit_group": UnitGroupSchemaOut.from_dict(obj["unit_group"]) if obj.get("unit_group") is not None else None
        })
        return _obj


